<template>
    <div>
        <b-card border-variant="primary" header-bg-variant="primary"
                header-text-variant="white" header="Mitarbeiterkonto bearbeiten" class="text-center mx-auto"
                style="width: 20rem;  min-height:17rem; font-size: larger;">
            <b-card-img src="src/assets/writing.png" img-top style="max-width:5rem;"></b-card-img>
            <b-button class="mt-4" style="font-size:large;" squared href="#" block variant="outline-primary"
                      @click="$bvModal.show('modalBearbeiten')">
                Ein bestehendes Mitarbeiterkonto bearbeiten
            </b-button>
            <b-modal size="lg" ref="modalBearbeiten" id="modalBearbeiten" title="Ein Mitarbeiterkonto bearbeiten"
                     hide-footer centered>
                <p class="my-2">Bitte wählen Sie einen Mitarbeiter über dessen Personalnummer aus:</p>
                                <b-form-input v-model="selected" v-on:change="resetValues()" id="input-personalnummer-auswahl"
                              class="mt-3"></b-form-input>
                <hr class="my-4">
                <div v-if="selected" style="max-height:24vm;">
                    <b-row class="my-2 my-md-0 mx-auto align-middle row-cols-lg-4 row-cols-xl-4 row-cols-md-1">
                        <b-col class="my-auto pl-lg-0 pl-xl-0" sm="2">
                            <b-label for="input-vorname">Vorname:</b-label>
                        </b-col>
                        <b-col class="my-auto my-md-2" sm="4">
                            <b-form-input v-model="input_vorname" id="input-vorname"
                                          placeholder="(unverändert)"></b-form-input>
                        </b-col>
                        <b-col class="my-auto" sm="2">
                            <b-label for="input-nachname">Nachname:</b-label>
                        </b-col>
                        <b-col class="my-auto my-md-2 pr-lg-0 pr-xl-0" sm="4">
                            <b-form-input v-model="input_nachname" id="input-nachname"
                                          placeholder="(unverändert)"></b-form-input>
                        </b-col>
                    </b-row>
                    <b-row class="mt-2 mt-md-0 mb-lg-4 mb-xl-4 mx-auto row-cols-lg-4 row-cols-xl-4 row-cols-md-1">
                        <b-col class="my-auto pl-lg-0 pl-xl-0" sm="2">
                            <b-label for="input-personalnummer">Personalnummer:</b-label>
                        </b-col>
                        <b-col class="my-auto my-md-2" sm="4">
                            <b-form-input id="input-personalnummer" disabled
                                          v-model="selected"></b-form-input>
                        </b-col>
                    </b-row>
                    <b-row class="mb-2 mb-md-0 mt-lg-4 mt-xl-4 mx-auto row-cols-lg-4 row-cols-xl-4 row-cols-md-1">
                        <b-col class="my-auto pl-lg-0 pl-xl-0" sm="2">
                            <b-label for="input-strasse">Straße:</b-label>
                        </b-col>
                        <b-col class="my-auto my-md-2" sm="4">
                            <b-form-input v-model="input_strasse" id="input-strasse"
                                          placeholder="(unverändert)"></b-form-input>
                        </b-col>
                        <b-col class="my-auto" sm="2">
                            <b-label for="input-hausnummer">Hausnummer:</b-label>
                        </b-col>
                        <b-col class="my-auto my-md-2 pr-lg-0 pr-xl-0" sm="4">
                            <b-form-input v-model="input_hausnummer" id="input-hausnummer"
                                          placeholder="(unverändert)"></b-form-input>
                        </b-col>
                    </b-row>
                    <b-row class="my-2 my-md-0 mx-auto row-cols-lg-4 row-cols-xl-4 row-cols-md-1">
                        <b-col class="my-auto pl-lg-0 pl-xl-0" sm="2">
                            <b-label for="input-plz">Postleitzahl:</b-label>
                        </b-col>
                        <b-col class="my-auto my-md-2" sm="4">
                            <b-form-input v-model="input_plz" id="input-plz"
                                          placeholder="(unverändert)"></b-form-input>
                        </b-col>
                        <b-col class="my-auto" sm="2">
                            <b-label for="input-ort">Wohnort:</b-label>
                        </b-col>
                        <b-col class="my-auto my-md-2 pr-lg-0 pr-xl-0" sm="4">
                            <b-form-input v-model="input_ort" id="input-ort"
                                          placeholder="(unverändert)"></b-form-input>
                        </b-col>
                    </b-row>
                    <b-row class="my-2 my-md-0 mx-auto row-cols-lg-4 row-cols-xl-4 row-cols-md-1">
                        <b-col class="my-auto pl-lg-0 pl-xl-0" sm="2">
                            <b-label for="input-telefonnummer">Telefonnummer:</b-label>
                        </b-col>
                        <b-col class="my-auto my-md-2" sm="4">
                            <b-form-input v-model="input_telefonnummer" id="input-telefonnummer"
                                          placeholder="(unverändert)"></b-form-input>
                        </b-col>
                        <b-col class="my-auto" sm="2">
                            <b-label for="input-email">E-Mail:</b-label>
                        </b-col>
                        <b-col class="my-auto my-md-2 pr-lg-0 pr-xl-0" sm="4">
                            <b-form-input v-model="input_email" id="input-email"
                                          placeholder="(unverändert)"></b-form-input>
                        </b-col>
                    </b-row>
                    <b-row class="mb-2 mb-md-0 mt-lg-4 mt-xl-4 mx-auto row-cols-lg-4 row-cols-xl-4 row-cols-md-1">
                        <b-col class="my-auto pl-lg-0 pl-xl-0" sm="2">
                            <b-label for="input-passwort">Passwort:</b-label>
                        </b-col>
                        <b-col class="my-auto my-md-2" sm="4">
                            <b-form-input v-model="input_passwort" id="input-passwort"
                                          placeholder="(unverändert)"></b-form-input>
                        </b-col>
                        <b-col class="my-auto" sm="2">
                            <b-label for="input-admin">Adminrechte:</b-label>
                        </b-col>
                        <b-col class="my-auto pr-lg-0 pr-xl-0" sm="4">
                            <b-form-select id="input-admin" v-model="admin_auswahl"
                                           :options="admin_optionen"></b-form-select>
                        </b-col>
                    </b-row>
                </div>
                <div v-else style="min-height:23.25rem; text-align: center;">
                    <p style="color: gray;" class="pt-5">Kein Mitarbeiter ausgewählt</p>
                </div>
                <b-row class="row-cols-2 mt-4">
                    <b-col>
                        <b-button block class="mt-3" @click="$bvModal.hide('modalBearbeiten')">Abbrechen</b-button>
                    </b-col>
                    <b-col>
                        <b-button v-if="selected" block variant="primary" class="mt-3"
                                  v-on:click="$bvModal.show('modalAntwort') & abschicken() & $bvModal.hide('modalBearbeiten')">Speichern & Fortfahren
                        </b-button>
                        <b-button v-else block variant="outline-primary" style="cursor: default;" disabled class="mt-3"
                        >Speichern & Fortfahren
                        </b-button>
                    </b-col>
                </b-row>
            </b-modal>
            <b-modal ref="modalAntwort" id="modalAntwort" centered size="xs" title="" hide-footer>
                {{this.modalAntwortText}}
                <b-button block variant="primary" class="mt-3"
                          @click="$bvModal.hide('modalAntwort')"
                >Fortfahren
                </b-button>
            </b-modal>
        </b-card>
    </div>
</template>

<script>
    import {mapState} from "vuex";
    import sha1 from "sha1";
    import axios from 'axios';

    export default {

        computed: mapState([
            'istAdmin',
            'sessionId',
            'personalnummer'
        ]),
        data: function () {
            return {
                modalAntwortText: "",
                selected: null,
                admin_auswahl: null,
                nummer_optionen: [],
                admin_optionen:
                    [
                        {value: null, text: 'Bitte auswählen'},
                        {value: true, text: 'Ja'},
                        {value: false, text: 'Nein'}
                    ],
                input_vorname: "",
                input_nachname: "",
                input_strasse: "",
                input_hausnummer: "",
                input_plz: "",
                input_ort: "",
                input_telefonnummer: "",
                input_email: "",
                input_passwort: "",
            }
        },
        methods: {
            showAlert: function (text, variant) {
                this.alert_visible = true;
                this.alert_text = text;
                this.alert_variant = variant;
            },
            resetValues: function () {
                this.input_vorname = "";
                this.input_nachname = "";
                this.input_strasse = "";
                this.input_hausnummer = "";
                this.input_plz = "";
                this.input_ort = "";
                this.input_telefonnummer = "";
                this.input_email = "";
                this.input_passwort = "";
                this.admin_auswahl = null;
            },
            abschicken : async function()  {
                var inhalt = {
                    "Session": {
                        "CID": this.$store.state.sessionId
                    },
                    "Mitarbeiter": {
                        "Personalnummer": this.input_personalnummer,
                        "Nachname": this.input_nachname,
                        "Vorname": this.input_vorname,
                        "Strasse": this.input_strasse,
                        "Hausnummer": this.input_hausnummer,
                        "PLZ": this.input_plz,
                        "Ort": this.input_ort,
                        "Telefon": this.input_telefonnummer,
                        "E_Mail": this.input_email,
                        "PasswordHash": sha1(this.input_passwort),
                        "IsAdmin": this.admin_auswahl,
                    }
                };
                var url = "http://127.0.0.1:5678/appServer/MitarbeiterBearbeiten";
                var inhalt_json = JSON.stringify(inhalt);
                const {data, status} = await axios.post(url, inhalt_json);
                console.log(data);
                console.log(status);
                if (status !== 200) {
                    this.modalAntwortText = data.Response;
                } else {
                    this.modalAntwortText = "Daten erfolgreich gespeichert!"
                }
            }
        },
    }


</script>